xmltooling::ChainingTrustEngine Class Reference

OpenSSLTrustEngine that uses multiple engines in sequence. More...

`#include <xmltooling/security/ChainingTrustEngine.h>`

Inheritance diagram for xmltooling::ChainingTrustEngine:
[legend]
Collaboration diagram for xmltooling::ChainingTrustEngine:
[legend]

## Public Member Functions

| ChainingTrustEngine (const xercesc::DOMElement *e=0, bool deprecationSupport=true)
| Constructor.
virtual | ~ChainingTrustEngine ()
| Destructor will delete any embedded engines.
void | addTrustEngine (TrustEngine *newEngine)
| Adds a trust engine for future calls.
TrustEngine * | removeTrustEngine (TrustEngine *oldEngine)
| Removes a trust engine.
bool | validate (xmlsignature::Signature &sig, const CredentialResolver &credResolver, CredentialCriteria *criteria=0) const
| Determines whether an XML signature is correct and valid with respect to the source of credentials supplied.
bool | validate (const XMLCh *sigAlgorithm, const char *sig, xmlsignature::KeyInfo *keyInfo, const char *in, unsigned int in_len, const CredentialResolver &credResolver, CredentialCriteria *criteria=0) const
| Determines whether a raw signature is correct and valid with respect to the source of credentials supplied.
bool | validate (XSECCryptoX509 *certEE, const std::vector< XSECCryptoX509 * > &certChain, const CredentialResolver &credResolver, CredentialCriteria *criteria=0) const
| Determines whether an X.509 credential is valid with respect to the source of credentials supplied.
bool | validate (X509 *certEE, STACK_OF(X509) *certChain, const CredentialResolver &credResolver, CredentialCriteria *criteria=0) const
| Determines whether an X.509 credential is valid with respect to the source of credentials supplied.
Public Member Functions inherited from xmltooling::TrustEngine
void | setKeyInfoResolver (KeyInfoResolver *keyInfoResolver)
| Supplies a KeyInfoResolver instance.
Public Member Functions inherited from xmltooling::OpenSSLTrustEngine
virtual bool | validate (XSECCryptoX509 *certEE, const std::vector< XSECCryptoX509 * > &certChain, const CredentialResolver &credResolver, CredentialCriteria *criteria=0) const=0
| Determines whether an X.509 credential is valid with respect to the source of credentials supplied.

## Additional Inherited Members

Protected Member Functions inherited from xmltooling::SignatureTrustEngine
| SignatureTrustEngine (const xercesc::DOMElement *e=0, bool deprecationSupport=true)
| Constructor.
Protected Member Functions inherited from xmltooling::TrustEngine
| TrustEngine (const xercesc::DOMElement *e=0, bool deprecationSupport=true)
| Constructor.
Protected Member Functions inherited from xmltooling::OpenSSLTrustEngine
| OpenSSLTrustEngine (const xercesc::DOMElement *e=0, bool deprecationSupport=true)
| Constructor.
Protected Member Functions inherited from xmltooling::X509TrustEngine
| X509TrustEngine (const xercesc::DOMElement *e=0, bool deprecationSupport=true)
| Constructor.
Protected Attributes inherited from xmltooling::TrustEngine
KeyInfoResolver * | m_keyInfoResolver
| Custom KeyInfoResolver instance.

## Detailed Description

OpenSSLTrustEngine that uses multiple engines in sequence.

## Constructor & Destructor Documentation

## ChainingTrustEngine()

xmltooling::ChainingTrustEngine::ChainingTrustEngine | ( | const xercesc::DOMElement * | e = 0,
|  | bool | deprecationSupport = true )

Constructor.

If a DOM is supplied, the following XML content is supported:

- <TrustEngine> elements with a type attribute

XML namespaces are ignored in the processing of this content.

Parameters

  e | DOM to supply configuration for provider
  deprecationSupport | true iff the plugin(s) should support any deprecated features

## Member Function Documentation

## addTrustEngine()

void xmltooling::ChainingTrustEngine::addTrustEngine | ( | TrustEngine * | newEngine | ) |

Adds a trust engine for future calls.

Parameters

  newEngine | trust engine to add

## removeTrustEngine()

TrustEngine * xmltooling::ChainingTrustEngine::removeTrustEngine | ( | TrustEngine * | oldEngine | ) |

Removes a trust engine.

The caller must delete the engine if necessary.

Parameters

  oldEngine | trust engine to remove

Returns
  the old engine

## validate() [1/4]

bool xmltooling::ChainingTrustEngine::validate | ( | const XMLCh * | sigAlgorithm,
|  | const char * | sig,
|  | xmlsignature::KeyInfo * | keyInfo,
|  | const char * | in,
|  | unsigned int | in_len,
|  | const CredentialResolver & | credResolver,
|  | CredentialCriteria * | criteria = 0 ) const

virtual

Determines whether a raw signature is correct and valid with respect to the source of credentials supplied.

It is the responsibility of the application to ensure that the Credentials supplied are in fact associated with the peer who created the signature.

If criteria with a peer name are supplied, the "name" of the Credential that verifies the signature may also be checked to ensure that it identifies the intended peer. The peer name itself or implementation-specific rules based on the content of the peer credentials may be applied. Implementations may omit this check if they deem it unnecessary.

Note that the keyInfo parameter is not part of the implicitly trusted set of information supplied via the CredentialResolver, but rather advisory data that may have accompanied the signature itself.

Parameters

  sigAlgorithm | XML Signature identifier for the algorithm used
  sig | null-terminated base64-encoded signature value
  keyInfo | KeyInfo object accompanying the signature, if any
  in | the input data over which the signature was created
  in_len | size of input data in bytes
  credResolver | a locked resolver to supply trusted peer credentials to the TrustEngine
  criteria | criteria for selecting peer credentials

Returns
  true iff the signature validates

Implements xmltooling::SignatureTrustEngine.

## validate() [2/4]

bool xmltooling::ChainingTrustEngine::validate | ( | X509 * | certEE,
|  | STACK_OF(X509) * | certChain,
|  | const CredentialResolver & | credResolver,
|  | CredentialCriteria * | criteria = 0 ) const

virtual

Determines whether an X.509 credential is valid with respect to the source of credentials supplied.

It is the responsibility of the application to ensure that the credentials supplied are in fact associated with the peer who presented the credential.

If criteria with a peer name are supplied, the "name" of the EE certificate may also be checked to ensure that it identifies the intended peer. The peer name itself or implementation-specific rules based on the content of the peer credentials may be applied. Implementations may omit this check if they deem it unnecessary.

Parameters

  certEE | end-entity certificate to validate
  certChain | the complete set of certificates presented for validation (includes certEE)
  credResolver | a locked resolver to supply trusted peer credentials to the TrustEngine
  criteria | criteria for selecting peer credentials

Implements xmltooling::OpenSSLTrustEngine.

## validate() [3/4]

bool xmltooling::ChainingTrustEngine::validate | ( | xmlsignature::Signature & | sig,
|  | const CredentialResolver & | credResolver,
|  | CredentialCriteria * | criteria = 0 ) const

virtual

Determines whether an XML signature is correct and valid with respect to the source of credentials supplied.

It is the responsibility of the application to ensure that the credentials supplied are in fact associated with the peer who created the signature.

If criteria with a peer name are supplied, the "name" of the Credential that verifies the signature may also be checked to ensure that it identifies the intended peer. The peer name itself or implementation-specific rules based on the content of the peer credentials may be applied. Implementations may omit this check if they deem it unnecessary.

Parameters

  sig | reference to a signature object to validate
  credResolver | a locked resolver to supply trusted peer credentials to the TrustEngine
  criteria | criteria for selecting peer credentials

Returns
  true iff the signature validates

Implements xmltooling::SignatureTrustEngine.

## validate() [4/4]

bool xmltooling::ChainingTrustEngine::validate | ( | XSECCryptoX509 * | certEE,
|  | const std::vector< XSECCryptoX509 * > & | certChain,
|  | const CredentialResolver & | credResolver,
|  | CredentialCriteria * | criteria = 0 ) const

virtual

Determines whether an X.509 credential is valid with respect to the source of credentials supplied.

It is the responsibility of the application to ensure that the credentials supplied are in fact associated with the peer who presented the credential.

If criteria with a peer name are supplied, the "name" of the EE certificate may also be checked to ensure that it identifies the intended peer. The peer name itself or implementation-specific rules based on the content of the peer credentials may be applied. Implementations may omit this check if they deem it unnecessary.

Parameters

  certEE | end-entity certificate to validate
  certChain | the complete set of certificates presented for validation (includes certEE)
  credResolver | a locked resolver to supply trusted peer credentials to the TrustEngine
  criteria | criteria for selecting peer credentials

Implements xmltooling::X509TrustEngine.

The documentation for this class was generated from the following file:

- xmltooling/security/ChainingTrustEngine.h